<?php
/**
 * @version   1.4 November 13, 2012
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

class ZephyrFusionMenuLayout extends AbstractRokMenuLayout {

    public function stageHeader() {
        global $gantry;
        if ($this->args['fusion_effect'] == 'slidefade') $this->args['fusion_effect'] = "slide and fade";
         if ($gantry->browser->name == "ie" && $gantry->browser->shortversion == "6"){
            $this->args['fusion_enable_js'] = 0;
            $gantry->addScript('sfhover.js');
         }

        $gantry->addStyle($gantry->templateUrl."/css/fusionmenu.css");

        if ($gantry->browser->name == "ie" && $this->args['fusion_effect'] == 'slide and fade') $this->args['fusion_effect'] = "slide";
        
        if ($this->args['fusion_enable_js']) {
            $gantry->addScript("fusion.js");

            ob_start();
            ?>
            new Fusion('ul.menutop', {
                pill: <?php echo $this->args['fusion_pill']; ?>,
                effect: '<?php echo $this->args['fusion_effect']; ?>',
                opacity:  <?php echo $this->args['fusion_opacity']; ?>,
                hideDelay:  <?php echo $this->args['fusion_hidedelay']; ?>,
                centered:  <?php echo $this->args['fusion_centeredOffset']; ?>,
                tweakInitial: {'x': <?php echo $this->args['fusion_tweakInitial_x']; ?>, 'y': <?php echo $this->args['fusion_tweakInitial_y']; ?>},
                tweakSubsequent: {'x':  <?php echo $this->args['fusion_tweakSubsequent_x']; ?>, 'y':  <?php echo $this->args['fusion_tweakSubsequent_y']; ?>},
                tweakSizes: {'width': <?php echo $this->args['fusion_tweak-width']; ?>, 'height': <?php echo $this->args['fusion_tweak-height']; ?>},
                menuFx: {duration:  <?php echo $this->args['fusion_menu_duration']; ?>, transition: Fx.Transitions.<?php echo $this->args['fusion_menu_animation']; ?>},
                pillFx: {duration:  <?php echo $this->args['fusion_pill_duration']; ?>, transition: Fx.Transitions.<?php echo $this->args['fusion_pill_animation']; ?>}
            });
            <?php
            $inline = ob_get_clean();
            $gantry->addDomReadyScript($inline);
        }
        if ($this->args['fusion_load_css']) {
            $gantry->addStyle($gantry->templateUrl."/html/gantrymenu/themes/gantry_fusion/css/fusion.css");
        }

    }

    public function renderMenu(&$menu) {
    	global $gantry;  	
    	if (!$this->args['fusion_enable_js']) $isJSEnabled = 'nojs';   	
        ob_start();
        if (!$this->args['fusion_pill']): ?>
		<div class="nopill">
		<?php endif; ?>
        <ul class="menutop level1 theme-fusion <?php echo $isJSEnabled; ?>">
	        <?php foreach ($menu->getChildren() as $item) : ?>
		        <?php echo $this->renderItem($item, $menu); ?>
	        <?php endforeach; ?>
        </ul>
        <?php if (!$this->args['fusion_pill']): ?>
		</div>
		<?php endif;
        return ob_get_clean();
    }
    
    protected function array_chunkd(array $array, $chunk) {
        if ($chunk === 0)
            return $array;

        // number of elements in an array
        $size = count($array);

        // average chunk size
        $chunk_size = $size / $chunk;

        // calculate how many not-even elements eg in array [3,2,2] that would be element "3"
        $real_chunk_size = floor($chunk_size);
        $diff = $chunk_size - $real_chunk_size;
        $not_even = $diff > 0 ? round($chunk * $diff) : 0;

        // initialise values for return
        $result = array();
        $current_chunk = 0;

        foreach ($array as $key => $element)
        {
            $count = isset($result[$current_chunk]) ? count($result[$current_chunk]) : 0;

            // move to a new chunk?
            if ($count == $real_chunk_size && $current_chunk >= $not_even || $count > $real_chunk_size && $current_chunk < $not_even)
                $current_chunk++;

            // save value
            $result[$current_chunk][$key] = $element;
        }

        return $result;
    }

    protected function renderItem(RokMenuNode &$item, &$menu) {
        global $gantry;
        
        $wrapper_css = '';
        $ul_css = '';
        $group_css = '';
        
        //get custom image
        if ($item->getAttribute('icon'))
            $item->addLinkClass('image');
        else
            $item->addLinkClass('bullet');
        
        // get menu item subtext
        if ($item->getAttribute('subtext'))
            $item->addLinkClass('subtext');
            
        //get columns count for children
	    $columns = $item->getAttribute('submenu_cols');
            
        $dropdown_width = $item->getAttribute('fusion_dropdown_width');
        $column_widths = explode(",",$item->getAttribute('fusion_column_widths'));

        if (trim($columns)=='') $columns = 1;
        if (trim($dropdown_width)=='') $dropdown_width = 180;

        $wrapper_css = ' style="width:'.trim($dropdown_width).'px;"';

        $col_total = 0;$cols_left=$columns;
        if (trim($column_widths[0] != '')) {
            for ($i=0; $i < $columns; $i++) {
                if (isset($column_widths[$i])) {
                    $ul_css[] = ' style="width:'.trim($column_widths[$i]).'px;"';
                    $col_total += $column_widths[$i];
                    $cols_left--;
                } else {
                    $col_width = floor(intval((intval($dropdown_width) - $col_total) / $cols_left));
                    $ul_css[] = ' style="width:'.$col_width.'px;"';
                }
            }
        } else {
            for ($i=0; $i < $columns; $i++) {
                $col_width = floor(intval($dropdown_width)/$columns);
                $ul_css[] = ' style="width:'.$col_width.'px;"';
            }
        }
        
        // Menu Item Grouping
        
        $grouping = $item->getAttribute('fusion_children_group');
        if ($grouping == 1) $item->addListItemClass('grouped-parent');    
        $child_type = 'menuitems';
                  
        ?>
        
        <li <?php if($item->hasListItemClasses()) : ?>class="<?php echo $item->getListItemClasses();?>"<?php endif;?> <?php if ($item->getCssId()): ?>id="<?php echo $item->getCssId();?>"<?php endif;?>>
            <a <?php if ($item->hasLinkClasses()): ?>class="<?php echo $item->getLinkClasses();?>" <?php endif;?><?php if ($item->hasLink()): ?>href="<?php echo $item->getLink();?>" <?php endif;?><?php if ($item->getTarget()): ?>target="<?php echo $item->getTarget();?>" <?php endif;?><?php if ($item->hasLinkAttribs()): ?> <?php echo $item->getLinkAttribs(); ?><?php endif;?>>
            <span>
             <?php
             $icon = $item->getAttribute('icon');
             ?>
             <?php if (!empty($icon)) : ?>
                 <img src="<?php echo $gantry->templateUrl.'/images/icons/'.$icon; ?>" alt="" />
             <?php endif; ?>
             <?php echo $item->getTitle();?>
             <?php
             $subtext = $item->getAttribute('subtext');
             if (is_array($subtext)) :
                 $subtext = implode("\n", $subtext);
             endif;
             ?>
             <?php if (!empty($subtext)): ?><em><?php echo stripslashes($subtext); ?></em><?php endif;?>
            </span>
            </a>
	        <?php if ($item->hasChildren()): ?>
		        <?php
	        	if ($grouping == 0 or $item->getLevel() == 0) :
		        	if ($item->getAttribute('fusion_distribution')=='inorder') {
	                    $count = sizeof($item->getChildren());
	                    $items_per_col = intval(ceil($count / $columns));
	                    $children_cols = array_chunk($item->getChildren(),$items_per_col);
	                } else {
	                    $children_cols = $this->array_chunkd($item->getChildren(),$columns);
	                }
	                $col_counter = 0;  
	            ?>
	        	<div class="fusion-submenu-wrapper navigation-overlay-<?php echo $gantry->get('navigation-overlay'); ?> level<?php echo intval($item->getLevel())+2; ?><?php if ($columns > 1) echo ' columns'.$columns; ?>"<?php echo $wrapper_css; ?>>
	        		<?php foreach($children_cols as $col) : ?>
		            <ul class="level<?php echo intval($item->getLevel()) + 2; ?>"<?php echo $ul_css[$col_counter++]; ?>>
			            <?php foreach ($col as $child) : ?>
				            <?php echo $this->renderItem($child, $menu); ?>
			            <?php endforeach; ?>
		            </ul>
		            <?php endforeach;?>
		            <div class="drop-bot"></div>
		        </div>
		        <?php else : ?>
	                <div class="fusion-grouped<?php echo $group_css; ?>">
	                    <ol>
	                        <?php foreach ($item->getChildren() as $child) : ?>
	                            <?php echo $this->renderItem($child, $menu); ?>
	                        <?php endforeach; ?>
	                    </ol>
	                </div>
	            <?php endif; ?>
	        <?php endif; ?>
        </li>
        <?php
    }
}