<?php
/**
 * @version   1.4 November 13, 2012
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
defined('GANTRY_VERSION') or die();

gantry_import('core.gantrylayout');

/**
 *
 * @package gantry
 * @subpackage html.layouts
 */
class GantryLayoutChrome_Standard extends GantryLayout {
    var $render_params = array(
        'gridCount'     =>  null,
        'prefixCount'   =>  0,
        'extraClass'      =>  ''
    );

    function render($params = array()){
        global $gantry, $wp_registered_widgets;
        $rparams = $this-> _getParams($params[0]);
        $instance_params = $this->_getWidgetInstanceParams($params[0]['widget_id']);
        
        $id =  $params[0]['widget_id'];
        $classname = $wp_registered_widgets[$params[0]['widget_id']]['classname'];

        // gantry render params
        $params[0]['pre_widget'] ='';
        $params[0]['widget_open'] ='';
        $params[0]['title_open'] ='';
        $params[0]['title_close'] ='';
        $params[0]['widget_close'] ='';
        $params[0]['post_widget'] ='';
        $params[0]['pre_render'] ='';
        $params[0]['post_render'] ='';

        // normal wp widget params
        $params[0]['before_widget'] = '';
        $params[0]['before_title']  = '';
        $params[0]['after_title']  = '';
        $params[0]['after_widget']  = '';

        if ((array_key_exists('widgetstyle',$instance_params) && $instance_params['widgetstyle']!='') || 
        	(array_key_exists('boxvariation',$instance_params) && $instance_params['boxvariation']!='') ||
        	(array_key_exists('titlevariation',$instance_params) && $instance_params['titlevariation']!='') ||
        	(array_key_exists('titlestyle',$instance_params) && $instance_params['titlestyle']!='')) {
        	
            if ($instance_params['boxvariation'] != '') : $instance_params['boxvariation'] = ' '.$instance_params['boxvariation']; endif;
            if ($instance_params['titlevariation'] != '') : $instance_params['titlevariation'] = ' '.$instance_params['titlevariation']; endif;
            if ($instance_params['titlestyle'] != '') : $instance_params['titlestyle'] = ' '.$instance_params['titlestyle']; endif;
            
            $widget_variations = $instance_params['widgetstyle'].$instance_params['boxvariation'].$instance_params['titlevariation'].$instance_params['titlestyle'];
            
            $params[0]['pre_widget'] = '<div class="'.$widget_variations.'">';
            $params[0]['post_widget'] = '</div>';
        }

        $params[0]['widget_open'] = sprintf('<div id="%1$s" class="widget %2$s rt-block">', $id, $classname);
        $params[0]['widget_close'] = '</div>';
        
        $params[0]['pre_render'] = '<div class="rt-module-surround"><div class="rt-module-inner"><div class="module-content">';
        $params[0]['post_render'] = '<div class="clear"></div></div></div></div>';

        $params[0]['title_open'] =  '<div class="module-title-surround"><div class="module-title"><h2 class="title">';
        $params[0]['title_close'] = '</h2></div></div>';

        if($instance_params['title'] != '') :
	        $params[0]['before_widget'] = $params[0]['pre_widget'].$params[0]['widget_open'];
	        $params[0]['before_title'] = $params[0]['title_open'];
	        $params[0]['after_title'] =  $params[0]['title_close'].$params[0]['pre_render'];
	        $params[0]['after_widget'] = $params[0]['post_render'].$params[0]['widget_close'].$params[0]['post_widget'];
		else :
			$params[0]['before_widget'] = $params[0]['pre_widget'].$params[0]['widget_open'].$params[0]['pre_render'];
	        $params[0]['before_title'] = $params[0]['title_open'];
	        $params[0]['after_title'] =  $params[0]['title_close'];
	        $params[0]['after_widget'] = $params[0]['post_render'].$params[0]['widget_close'].$params[0]['post_widget'];
		endif;
        
        return $params;
        
    }
}